! Low-pass filter for use on 16-bit mono audio
! Mic, 2013
!
! If the sampling rate or maximum sample amplitude is changed, the
! sample bias will have to be adjusted.

.text

! void LowpassFilter(int16_t *filtered, int16_t *src, uint32_t count);
! On entry: r4 = pointer to buffer that will receive the mixed/filtered samples (mono)
!           r5 = input buffer pointer (mono)
!           r6 = count (number of samples)
!
	.align 4
	.global _LowpassFilter
_LowpassFilter:
        mov.l   r10,@-r15
        mov.l   r11,@-r15
        mov.l   r12,@-r15

	mov 	#118,r12
 	shll 	r12		/* sample bias (236) */

	mov.l	filterFactor,r0
	mov.l	@r0,r1
	
	mov.w 	@r5+,r0		/* r0 = src[0] */
	mov	r0,r3
	add	r12,r0
	mov.w 	r0,@r4		/* filtered[0] = src[0]
	dt	r6
	/* for i = 1..count-1 do */
        /*   filtered[i] = filtered[i-1] + filterFactor/256 * (src[i] - filtered[i-1]) */
filter_loop:
	mov.w 	@r5+,r0		/* r0 = src[i] */
	
	sub 	r3,r0		/* r0 = src[i] - filtered[i-1] */
	muls.w 	r0,r1		/* macl = filterFactor * (src[i] - filtered[i-1]) */
	sts	macl,r0
	shlr8	r0		/* r0 = filterFactor/256 * (src[i] - filtered[i-1]) */
	exts.w	r0,r0
	add	#2,r4	
	add	r3,r0
	mov	r0,r3
	add	r12,r0
	dt	r6
	mov.w	r0,@r4		/* filtered[i] = filtered[i-1] + filterFactor/256 * (src[i] - filtered[i-1]) */
	bf	filter_loop
	
        mov.l   @r15+,r12
        mov.l   @r15+,r11
        mov.l   @r15+,r10
	rts
	nop

.align 2
filterFactor: .long _filterFactor

