#include <string.h>
#include "ym_emu.h"

#define NUM_SAMPLES (SAMPLE_RATE/50)

#include "32x.h"
#include "sound.h"

// From songs/songs.s
extern const uint8_t *SONG_POINTERS[];
extern const size_t SONG_SIZES[];

int16_t __attribute__((aligned(16))) snd_buffer[MAX_NUM_SAMPLES*2*2];
int16_t __attribute__((aligned(16))) temp_buffer[NUM_SAMPLES*2];

uint16_t num_samples = NUM_SAMPLES;

extern int8_t mvolume;
size_t slaveCurrSong = 0;
extern volatile uint32_t *playCmdCacheThrough;
extern volatile int16_t **sampleBufferCacheThrough;
uint32_t soundTimeMs = 0;
extern volatile uint32_t *soundTimeMsCacheThrough;

// From mixer.s
extern void LowpassFilter(int16_t *filtered, int16_t *src, uint32_t count);


void fill_buffer(int16_t *buffer)
{
	num_samples = NUM_SAMPLES;

    LockMixer(MIXER_LOCK_SSH2);

	*soundTimeMsCacheThrough += (20 << 8) + 1;
	if (*soundTimeMsCacheThrough >= (6000000 << 8)) {
		*soundTimeMsCacheThrough -= (6000000 << 8);
	}

    if (CMD_SWITCH_SONG == ((*playCmdCacheThrough) & 0x00FF0000)) {
		slaveCurrSong = (*playCmdCacheThrough) & 0xFF;
		*playCmdCacheThrough = CMD_IDLE;
		ym_emu_init(SONG_POINTERS[slaveCurrSong]);
	}

    ym_emu_run(NUM_SAMPLES, temp_buffer);
    *sampleBufferCacheThrough = buffer;
    UnlockMixer();

    LowpassFilter(buffer, temp_buffer, NUM_SAMPLES);
}


