// YM emulator for the 32X
// Mic, 2013

#pragma once

#include <stdint.h>

#define SFX_SID_VOICE 0
#define SFX_DIGI_DRUM 1
#define SFX_SINUS_SID 2
#define SFX_SYNC_BUZZ 3
#define SFX_NONE	  64

#define DIGI_DRUM_U4 0
#define DIGI_DRUM_U8 1
#define DIGI_DRUM_S8 2

extern char *ymSongTitle, *ymSongAuthor, *ymSongComment;

typedef struct
{
	union {
		uint32_t amplitude;
		uint32_t sampleNum;
	};
	union {
		uint32_t samplePos;
		uint32_t currentValue;
	};
	uint32_t timerCount, timerPeriod;
	int8_t typ;
	int8_t channel, channelSticky;
} ymEffect;


void ym_emu_init(const unsigned char *ymData);
void ym_emu_run(uint32_t numSamples, int16_t *buffer);


